#!/bin/bash

if [[ -z $1 ]]; then
    echo "first argument must be the node id"
    exit
fi

if [[ -n $2 && -c $2 ]]; then
    TMOTE_PORT=$2;
    echo "take port $TMOTE_PORT..."
else
    TMOTE_PORT=/dev/ttyUSB0
    if [[ -n $2 ]]; then
      echo "second argument is not a valid block special file, take default port $TMOTE_PORT..."
    else
      echo "no second argument specified, take default port $TMOTE_PORT..."
    fi
fi

IMAGE=TmoteBootloader20070223130600

rm -f $IMAGE-$1.bin
echo "change node id in binary..."
echo "tos-set-symbols --objcopy msp430-objcopy --objdump msp430-objdump --exe $IMAGE.bin $IMAGE-$1.bin TOS_NODE_ID=$1"
tos-set-symbols --objcopy msp430-objcopy --objdump msp430-objdump --exe $IMAGE.bin $IMAGE-$1.bin TOS_NODE_ID=$1

rm -f $IMAGE-$1.ihex
echo "convert to flash image (Intel Hex)..."
echo "msp430-objcopy --output-target=ihex $IMAGE-$1.bin $IMAGE-$1.ihex"
msp430-objcopy --output-target=ihex $IMAGE-$1.bin $IMAGE-$1.ihex

echo "burn image on Tmote..."
echo "tos-bsl -c $TMOTE_PORT -epvrI --tmote $IMAGE-$1.ihex"
tos-bsl -c $TMOTE_PORT -epvrI --tmote $IMAGE-$1.ihex

echo "done."
